misc: make public some scripts used by Jenkins
authorJean Privat <jean@pryen.org>
Thu, 28 Aug 2014 02:16:20 +0000 (22:16 -0400)
committerJean Privat <jean@pryen.org>
Thu, 28 Aug 2014 19:48:09 +0000 (15:48 -0400)
Signed-off-by: Jean Privat <jean@pryen.org>

misc/jenkins/README [new file with mode: 0644]
misc/jenkins/checksignedoffby.sh [new file with mode: 0755]
misc/jenkins/unitrun.sh [new file with mode: 0755]

diff --git a/misc/jenkins/README b/misc/jenkins/README
new file mode 100644 (file)
index 0000000..7fbe77c
--- /dev/null
@@ -0,0 +1 @@
+Some scripts used by the Nit Jenkins for continuous integration, but you can use them also.
diff --git a/misc/jenkins/checksignedoffby.sh b/misc/jenkins/checksignedoffby.sh
new file mode 100755 (executable)
index 0000000..bebd200
--- /dev/null
@@ -0,0 +1,49 @@
+#!/bin/bash
+# This file is part of NIT ( http://www.nitlanguage.org ).
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# Check missing signed-off-by in commits
+
+if test "$#" -lt 2; then
+       echo "Usage: checksignedoffby from to"
+       echo ""
+       exit
+fi
+
+from=$1
+to=$2
+
+err=0
+
+for ref in `git rev-list --no-merges "$from".."$to"`; do
+       # What is the expected?
+       sig=`git --no-pager show -s --format='Signed-off-by: %an <%ae>' $ref`
+       # Do we found some signed-off-by?
+       git --no-pager show -s --format="%b" $ref | grep "^Signed-off-by:" > check_signedoff_list.out || {
+               git --no-pager show -s --oneline $ref
+               echo "Missing $sig"
+               err=1
+               continue
+       }
+       # Do we found the expected thing?
+       cat check_signedoff_list.out | grep -q "^$sig\$" && continue
+       git --no-pager show -s --oneline $ref
+       echo "Bad or missing $sig; got:"
+       cat check_signedoff_list.out
+       err=1
+done
+
+rm check_signedoff_list.out 2> /dev/null
+
+exit $err
diff --git a/misc/jenkins/unitrun.sh b/misc/jenkins/unitrun.sh
new file mode 100755 (executable)
index 0000000..c652286
--- /dev/null
@@ -0,0 +1,51 @@
+#!/bin/bash
+# This file is part of NIT ( http://www.nitlanguage.org ).
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# This shell script executes a shell command and generates a JUnit compatible XML file
+
+if test $# -lt 2; then
+       echo "Usage: unitrun.sh name command"
+       echo "Runs the command and generates a JUnit XML file name.xml"
+       exit
+fi
+
+name=$1
+shift
+
+# Magic here! This tee and save both stdout and stderr in distinct files without messing with them
+# Time  just get the user time
+/usr/bin/time -f%U -o "${name}.t.out" "$@" > >(tee "${name}.out") 2> >(tee "${name}.2.out" >&2)
+res=$?
+
+cat > "${name}.xml"<<END
+<testsuites><testsuite>
+<testcase classname='other' name='$name' time='`cat "${name}.t.out"`' timestamp='`date -Iseconds`'>
+END
+if test "$res" != "0"; then
+echo >> "${name}.xml" "<error message='Command returned $res'/>"
+echo "+ Command returned $res" >&2
+fi
+cat >> "${name}.xml"<<END
+<system-out><![CDATA[
+`cat -v ${name}.out`
+]]></system-out>
+<system-err><![CDATA[
+`cat -v ${name}.2.out`
+]]></system-err>
+</testcase>
+</testsuite></testsuites>
+END
+
+rm "${name}.out" "${name}.2.out" "${name}.t.out"